package eel6788;

import yaes.framework.entity.control.ControlException;
import yaes.framework.simulation.IContext;
import yaes.framework.simulation.ISimulationCode;
import yaes.framework.simulation.SimulationInput;
import yaes.framework.simulation.SimulationOutput;
import yaes.framework.world.sensornetwork.AbstractSensorAgent;
import yaes.framework.world.sensornetwork.ActuatorNode;
import yaes.framework.world.sensornetwork.SensorNetworkWorld;
import yaes.framework.world.sensornetwork.SensorNode;

public class DirectedDiffusionSimulation implements ISimulationCode, Constants {
	public static String simulationLabel = "unlabelled";

	public void setup(SimulationInput sip, SimulationOutput sop,
			IContext theContext) {
		final DirectedDiffusionContext context =
				(DirectedDiffusionContext) theContext;
		context.initialize(sip, sop);
	}

    /**
     * Updates the simulation step.
     */
	public int update(double time, SimulationInput sip, SimulationOutput sop,
			IContext theContext) {
		final DirectedDiffusionContext context =
				(DirectedDiffusionContext) theContext;
		final SensorNetworkWorld sensorWorld =
				(SensorNetworkWorld) context.getWorld();
		context.getWorld().setTime((int) time);
		for (final SensorNode element : sensorWorld.getSensorNodes()) {
			try {
				element.update();
			} catch (final ControlException e) {
				e.printStackTrace();
			}
		}
		try {
			sensorWorld.getSinkNode().update();
		} catch (final ControlException e) {
			e.printStackTrace();
		}
		for (final ActuatorNode element : sensorWorld.getActuatorNodes()) {
			try {
				element.update(time);
			} catch (final ControlException e) {
				e.printStackTrace();
			}
		}
		if (context.getVisual() != null) {
			context.getVisual().repaint();
			try {
				Thread.sleep(10);
			} catch (final InterruptedException e) {
				e.printStackTrace();
			}
		}
		sensorWorld.messageFlush();
        // measures and prints the stealth values
		return 1;
	}

	/**
	 * Collect data about the data.
	 */
	public void postprocess(SimulationInput sip, SimulationOutput sop,
			IContext theContext) {
		final DirectedDiffusionContext context =
				(DirectedDiffusionContext) theContext;
		final SensorNetworkWorld sensorWorld =
				(SensorNetworkWorld) context.getWorld();
		for (final SensorNode node : sensorWorld.getSensorNodes()) {
			final AbstractSensorAgent asa = node.getAgent();
			// asa.postProcess();
		}
	}

	@Override
	public String toString() {
		return "DirectedDiffusion " + DirectedDiffusionSimulation.simulationLabel;
	}
}
