package eel6788.agents.directeddiffusion;

public class Gradient {
	private final String sensorName;
	private int duration;
	private int interval;
	private int lastMessageSent = 0;
	private int lastEmptyMessageSent = 0;

	public Gradient(String sensorName, int interval, int duration) {
		super();
		this.sensorName = sensorName;
		this.interval = interval;
		this.duration = duration;
	}

	public String getSensorName() {
		return sensorName;
	}

	public int getDuration() {
		return duration;
	}

	public int getInterval() {
		return interval;
	}

	public void update(int interval, int duration) {
		this.interval = interval;
		this.duration = duration;
	}

	public int getLastMessageSent() {
		return lastMessageSent;
	}

	/**
	 * This one also updates the last empty message sent.
	 * @param lastMessageSent
	 */
	public void setLastMessageSent(int lastMessageSent) {
		this.lastMessageSent = lastMessageSent;
		this.lastEmptyMessageSent = lastMessageSent;
	}
	
	@Override
	public String toString() {
		return "Gradient to " + sensorName + " interval:" + interval
				+ "  duration: " + duration + "  last sent: " + lastMessageSent + 
				" last empty: " + lastEmptyMessageSent;
	}

	public int getLastEmptyMessageSent() {
		return lastEmptyMessageSent;
	}

	public void setLastEmptyMessageSent(int lastEmptyMessageSent) {
		this.lastEmptyMessageSent = lastEmptyMessageSent;
	}
}
