package eel6788.agents.directeddiffusion;

import java.awt.geom.Rectangle2D;
import java.awt.geom.Rectangle2D.Double;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
/**
 * This class covers the interest for the sink. It is more comprehensive
 * that the class for the nodes, because captures the reasoning of the
 * sink.  
 * 
 * @author Lotzi Boloni
 *
 */
public class SinkInterest extends Interest {
	private int interval = Integer.MAX_VALUE;
	private int duration = 0;
	private final Map<Integer, List<String>> processedPerceptions =
		new TreeMap<Integer, List<String>>();
	
	
	public SinkInterest(String interestType, Double rectangle) {
		super(interestType, rectangle);
	}


	public int getInterval() {
		return interval;
	}


	public void setInterval(int interval) {
		this.interval = interval;
	}


	public int getDuration() {
		return duration;
	}


	public void setDuration(int duration) {
		this.duration = duration;
	}	
}
